#include "scripts.h"
#include <QDebug>

CScripts    scripts;

CScripts::CScripts()
{

}

//--------------------------------------------------------------------------
void CScripts::execute(std::string fileName)
{
    if (fileName.empty() == false)
    {
        lastIf = true;
        static char cFileName[256];
        static char line[256];

        sprintf(cFileName, "scripts/%s", fileName.c_str());
        FILE*   f = fopen(cFileName, "rt");

        while (fgets(line, 256, f) != NULL)
        {
            // split the line into words
            static std::vector<std::string>    words;
            words.clear();
            char* ptr;
            ptr = strtok(line," \t\r\n");

            while (ptr != NULL)
            {
                words.push_back(ptr);
                ptr = strtok(NULL, " \t\r\n");
            }

            // execute the line
            executeLine(words);
        }
        fclose (f);
    }
}

//--------------------------------------------------------------------------
void CScripts::executeLine(std::vector<std::string>& words)
{
    if (lastIf == true)
    {
        if (words[0] == "Target")
            executeTarget(words);
        else if (words[0] == "SetBool")
            executeSetBool(words);
        else if (words[0] == "SwitchBool")
            executeSwitchBool(words);
        else if (words[0] == "SetType")
            executeSetType(words);
        else if (words[0] == "SetEnum")
            executeSetEnum(words);
        else if (words[0] == "AddObject")
            executeAddObject(words);
        else if (words[0] == "If")
            executeIf(words);
        else if (words[0] == "SetString")
            executeSetString(words);
    }
    else
    {
        lastIf = true;
    }
}

//--------------------------------------------------------------------------
EWallSide CScripts::getWallSide(std::string word)
{
    if (word == "up")
        return eWallSideUp;
    else if (word == "down")
        return eWallSideDown;
    else if (word == "left")
        return eWallSideLeft;
    else if (word == "right")
        return eWallSideRight;
    else
        return eWallSideMax;
}

//--------------------------------------------------------------------------
void CScripts::executeTarget(std::vector<std::string>& words)
{
    mTargetPos.x = std::stoi(words[2]);
    mTargetPos.y = std::stoi(words[3]);
    CTile*  tile = map.getTile(mTargetPos);

    if (words[1] == "Tile")
    {
        mTargetType = eTargetType_Tile;
        mTargetSide = eWallSideMax;
        mTarget = (void*)tile;
    }
    else
    {
        mTargetType = eTargetType_Wall;
        mTargetSide = getWallSide(words[4]);
        mTarget = (void*)&tile->mWalls[mTargetSide];
    }
}

//--------------------------------------------------------------------------
void CScripts::executeSetBool(std::vector<std::string>& words)
{
    QString param = QString::fromStdString(words[1]);
    bool    value = (words[2] == "true" ? true : false);

    if (mTargetType == eTargetType_Tile)
        ((CTile*)mTarget)->setBoolParam(param, value);
    else
        ((CWall*)mTarget)->setBoolParam(param, value);
}

//--------------------------------------------------------------------------
void CScripts::executeSwitchBool(std::vector<std::string>& words)
{
    QString param = QString::fromStdString(words[1]);

    if (mTargetType == eTargetType_Tile)
    {
        CTile*  target = (CTile*)mTarget;
        bool    value = target->getBoolParam(param);
        target->setBoolParam(param, !value);
    }
    else
    {
        CWall*  target = (CWall*)mTarget;
        bool    value = target->getBoolParam(param);
        target->setBoolParam(param, !value);
    }
}

//--------------------------------------------------------------------------
void CScripts::executeSetType(std::vector<std::string>& words)
{
    int type = stoi(words[1]);

    if (mTargetType == eTargetType_Tile)
    {
    }
    else
    {
        CWall*  target = (CWall*)mTarget;
        target->setType(type);
    }
}

//--------------------------------------------------------------------------
void CScripts::executeSetEnum(std::vector<std::string>& words)
{
    QString param = QString::fromStdString(words[1]);
    int type = stoi(words[2]);

    if (mTargetType == eTargetType_Tile)
    {
    }
    else
    {
        CWall*  target = (CWall*)mTarget;
        target->setEnumParam(param, type);
    }
}

//--------------------------------------------------------------------------
void CScripts::executeAddObject(std::vector<std::string>& words)
{
    int type = stoi(words[1]);
    CObjectStack*   stack = map.addObjectsStack(mTargetPos, mTargetSide);
    CObject newObj;
    newObj.setType(type);
    stack->addObject(newObj);
}

//--------------------------------------------------------------------------
void CScripts::executeIf(std::vector<std::string>& words)
{
    CVec2   pos;
    pos.x = std::stoi(words[2]);
    pos.y = std::stoi(words[3]);
    CTile*  tile = map.getTile(pos);

    if (words[1] == "Tile")
    {
    }
    else
    {
        EWallSide   side = getWallSide(words[4]);
        CWall*  wall = &tile->mWalls[side];
        lastIf = wall->getBoolParam(QString::fromStdString(words[5]));
    }
}

//--------------------------------------------------------------------------
void CScripts::executeSetString(std::vector<std::string>& words)
{
    QString param = QString::fromStdString(words[1]);

    if (mTargetType == eTargetType_Tile)
    {
    }
    else
    {
        ((CWall*)mTarget)->setStringParam(param, words[2]);
    }
}
